function Util(){
    var EC = protractor.ExpectedConditions;
    var self = this;
    var ZeedhiAPIConstructor = require('zeedhi-functional-test-api');
    var z = new ZeedhiAPIConstructor(browser, protractor);

    this.elementVisible = function(locator){
        browser.wait(EC.visibilityOf(element(locator)), 30000).then(function(){
            //console.log("Elemento de locator " + locator + " encontrado");
        }, function(){
            //failure
            console.log("Elemento de locator " + locator + " não encontrado.");
            //throw "Elemento de locator " + locator + " não encontrado."    
        });
    };

    /*
    Aguarda o carregamento da Url informada em um timeout definido, contornando o problema da função browser.waitForAngular que causa erro de sincronização
    expectedUrl: string - url esperada (default = http://tecfoodteste.teknisa.com  - url inicial da aplicação)
    timeout: int - tempo de timeout para a url e angular serem carregados em milissegundos (default = 10000)
    */
    this.waitForAngular = function (expectedUrl = 'http://tecfoodteste.teknisa.com', timeout = 10000) {
            var loaded = false;

            browser.wait(function () {
                browser.executeScript(function () {
                    return {
                        url: window.location.href,
                        haveAngular: !!window.angular
                    };
                }).then(function (obj) {
                    /*Validar se a url esperada (expectedUrl) é exatamente igual a Url atual e o Angualr está carregado
                    loaded = (obj.url == expectedUrl && obj.haveAngular);*/

                    //Validar se a url esperada (expectedUrl) está contida na Url atual da aplicação e o Angualr está carregado
                    var actualUrl = obj.url;
                    loaded = (actualUrl.indexOf(expectedUrl) !== -1 && obj.haveAngular);
                });

                return loaded;
            }, timeout);
    };

    /*[TO DO] Em teste
    this.waitForElement = function (element, timeout = 10000) {
        return browser.wait(function () {
            return element.isPresent().then(function (isPresent) {
                if (isPresent) {
                    return element.isDisplayed();
                }
                else {
                    return false;
                }
            });
        }, timeout || TIMEOUT);
    };*/

    this.getCurrentMonth = function(){
        var date = new Date();
        var month = date.getMonth() + 1;

        switch(month){
            case 1:
                return 'Jan';
                break;

            case 2:
                return 'Fev';
                break;

            case 3:
                return 'Mar';
                break;

            case 4:
                return 'Abr';
                break;

            case 5:
                return 'Mai';
                break;

            case 6:
                return 'Jun';
                break;

            case 7:
                return 'Jul';
                break;

            case 8:
                return 'Ago';
                break;

            case 9:
                return 'Set';
                break;

            case 10:
                return 'Out';
                break;

            case 11:
                return 'Nov';
                break;

            case 12:
                return 'Dez';
                break;
        }
    };

    this.InteiroRandom = function (min, max) {
    return Math.floor(Math.random() * (max - min + 1) ) + min;
    };
    
}

module.exports = new Util();

